/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: PurgeTimerModelLocator.as 5569 2009-10-22 07:48:15Z ardaaydin $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.purgetimer.model
{

import com.adobe.cairngorm.model.ModelLocator;

import mx.controls.*;
import mx.utils.UIDUtil;

import org.ow2.jasmine.monitoring.eos.purgetimer.business.ExecuteActionDelegate;
import org.ow2.jasmine.monitoring.eos.purgetimer.business.IExecuteActionDelegate;
import org.ow2.jasmine.monitoring.eos.purgetimer.vo.ResultActionVO;

 /**
  * The model locator for the purge timer module.
  */
[Bindable]
public class PurgeTimerModelLocator implements ModelLocator
{
  /**
    * The unique ID of this component
    *
    * @internal
    *   Used to prevent a Cairngorm issue: when a command event is dispatched,
    * every controller that registered this event type receives it, even if
    * located in another module. To prevent this from happening and triggering
    * multiple severe unexpected concurrence bugs, each event dispatched is
    * postfixed with this unique ID.
    */
    public var componentID:String = UIDUtil.createUID();

     /**
    * Unique instance of this locator.
    */
    private static var model:PurgeTimerModelLocator = null;

 
    //
    //    Delegates
    //
    private var executeActionDelegate:IExecuteActionDelegate = null;



    // functions
    public function PurgeTimerModelLocator()
    {
        super();

        if (model != null) {
            throw new Error("Only one PurgeTimerModelLocator has to be set");
        }
    }

    public static function getInstance() : PurgeTimerModelLocator {
        if (PurgeTimerModelLocator.model == null) {
            PurgeTimerModelLocator.model = new PurgeTimerModelLocator();
        }

        return PurgeTimerModelLocator.model;
    }

    // setters


    // getters delegates

    public function getExecuteActionDelegate():IExecuteActionDelegate {
        if (this.executeActionDelegate == null) {
            this.executeActionDelegate = new ExecuteActionDelegate();
    	}
    	return this.executeActionDelegate;
    }

  	/**
   	* The last executed action.
   	*/
  	private var resultObj : ResultActionVO;

    public function set result(_result : ResultActionVO) : void {
        this.resultObj = _result;
    }

    public function get result() : ResultActionVO {
        return this.resultObj;
    }


}
}